from sceneNode import SceneNode
from circle import Circle

import math
import random

class Invader(SceneNode):
    def __init__(self, parent, type = None, name = None):
	SceneNode.__init__(self, parent, type, name)
	
	self.defaultVar("active", False)
	self.defaultVar("hitRadius", 5)
	self.defaultVar("distance", 275.0)
	self.defaultVar("velocity", 20)
	self.defaultVar("theta", random.randint(0,355))
	self.defaultVar("dead", False)
	
	self.gfxServer = self.getFirstObjectOfName("gfxServer")
	self.screenWidth = self.gfxServer.getVar("screenWidth")
	self.screenHeight = self.gfxServer.getVar("screenHeight")
	
	hr = self.getVar("hitRadius")
	self.setVar("scale", (hr*2, hr*2, hr*2))
	self.setVar("color", (0,0,1))
	
	theta = math.radians(self.getVar("theta"))
	r = self.getVar("distance")
	self.setVar("position",(r*math.cos(float(theta))+(self.screenWidth/2), r*math.sin(float(theta))+(self.screenHeight/2), 0))
	
	self.gfx = Circle(self)
	self.gfx.setVar("color", (1,0,0))
	self.addInitDependency("gfxServer")
	
    def update(self, timeTotal, timeDiff):
	velocity = self.getVar("velocity")
	r = self.getVar("distance")
	theta = self.getVar("theta")
	
	r = r - (velocity * timeDiff)
	self.setVar("position",(r*math.cos(float(theta))+(self.screenWidth/2), r*math.sin(float(theta))+(self.screenHeight/2), 0))
	self.setVar("distance", r)
