from object import Object
from background import Background
from text import Text
from rectangle import Rectangle
from OpenGL.GLUT import *
from menuManager import MenuManager

class LevelManager(Object):
    def __init__(self, parent, type = None, name = None):
	Object.__init__(self, parent, type, name)
	
	self.defaultVar("gameLevel", 1)
	
    def init(self):
	self.game = self.getFirstObjectOfName("odef")
	self.invaderManager = self.getFirstObjectOfName("invaderManager")
	self.background = self.getFirstObjectOfName("background")
	self.defender = self.getFirstObjectOfName("defender")
	
	self.gfxServer = self.getFirstObjectOfName("gfxServer")
	self.screenWidth = self.gfxServer.getVar("screenWidth")
	self.screenHeight = self.gfxServer.getVar("screenHeight")
	
	planet = self.getFirstObjectOfName("planet")
	planet.addSubscriber(self)
	
    def receiveMessage(self, cmd, msg = None):
	if cmd == "levelComplete":
	    level = self.getVar("gameLevel")
	    if level == 1:
		self.invaderManager.setVar("numInvaders", 0)
		self.invaderManager.setVar("numCurrentInvaders", 0)
		self.invaderManager.setVar("maxInvaders", 40)
		self.invaderManager.setVar("maxCurrentInvaders", 6)
		self.background.gfx.setVar("texture", "level2bg.png")
		self.setVar("gameLevel", level + 1)
		
		levelText = Text(self)
		levelText.setVar("caption", "LEVEL 2")
		levelText.setVar("position", (self.screenWidth/2-50, self.screenHeight/2-100, 0))
		levelText.setVar("size", GLUT_BITMAP_TIMES_ROMAN_24)
		levelText.timeToLive = 3
		self.gfxServer.lateObjects.append(levelText)
		
		self.defender.setVar("ammoRate", 6)
		self.defender.setVar("maxAmmo", 60)
	    elif level == 2:
		self.invaderManager.setVar("numInvaders", 0)
		self.invaderManager.setVar("numCurrentInvaders", 0)
		self.invaderManager.setVar("maxInvaders", 80)
		self.invaderManager.setVar("maxCurrentInvaders", 10)
		self.background.gfx.setVar("texture", "level3bg.png")
		self.setVar("gameLevel", level + 1)
		
		levelText = Text(self)
		levelText.setVar("caption", "LEVEL 3")
		levelText.setVar("position", (self.screenWidth/2-50, self.screenHeight/2-100, 0))
		levelText.setVar("size", GLUT_BITMAP_TIMES_ROMAN_24)
		levelText.timeToLive = 3
		self.gfxServer.lateObjects.append(levelText)
		
		self.defender.setVar("ammoRate", 7)
		self.defender.setVar("maxAmmo", 60)
	    elif level == 3:
		self.invaderManager.setVar("numInvaders", 0)
		self.invaderManager.setVar("numCurrentInvaders", 0)
		self.invaderManager.setVar("maxInvaders", 120)
		self.invaderManager.setVar("maxCurrentInvaders", 15)
		self.background.gfx.setVar("texture", "level4bg.png")
		self.setVar("gameLevel", level + 1)
		
		levelText = Text(self)
		levelText.setVar("caption", "LEVEL 4")
		levelText.setVar("position", (self.screenWidth/2-50, self.screenHeight/2-100, 0))
		levelText.setVar("size", GLUT_BITMAP_TIMES_ROMAN_24)
		levelText.timeToLive = 3
		self.gfxServer.lateObjects.append(levelText)
		
		self.defender.setVar("ammoRate", 8)
		self.defender.setVar("maxAmmo", 70)
	    elif level == 4:
		self.invaderManager.setVar("numInvaders", 0)
		self.invaderManager.setVar("numCurrentInvaders", 0)
		self.invaderManager.setVar("maxInvaders", 180)
		self.invaderManager.setVar("maxCurrentInvaders", 20)
		self.background.gfx.setVar("texture", "level5bg.png")
		self.setVar("gameLevel", level + 1)
		
		levelText = Text(self)
		levelText.setVar("caption", "LEVEL 5")
		levelText.setVar("position", (self.screenWidth/2-50, self.screenHeight/2-100, 0))
		levelText.setVar("size", GLUT_BITMAP_TIMES_ROMAN_24)
		levelText.timeToLive = 3
		self.gfxServer.lateObjects.append(levelText)
		
		self.defender.setVar("ammoRate", 8)
		self.defender.setVar("maxAmmo", 70)
	    elif level == 5:
		self.invaderManager.setVar("numInvaders", 0)
		self.invaderManager.setVar("numCurrentInvaders", 0)
		self.invaderManager.setVar("maxInvaders", 300)
		self.invaderManager.setVar("maxCurrentInvaders", 30)
		self.background.gfx.setVar("texture", "level6bg.png")
		self.setVar("gameLevel", level + 1)
		
		levelText = Text(self)
		levelText.setVar("caption", "LEVEL 6")
		levelText.setVar("position", (self.screenWidth/2-50, self.screenHeight/2-100, 0))
		levelText.setVar("size", GLUT_BITMAP_TIMES_ROMAN_24)
		levelText.timeToLive = 3
		self.gfxServer.lateObjects.append(levelText)
		
		self.defender.setVar("ammoRate", 10)
		self.defender.setVar("maxAmmo", 80)
	    elif level == 6:
		self.invaderManager.setVar("maxInvaders", 1)
		self.invaderManager.setVar("numInvaders", 2)
		levelText = Text(self)
		levelText.setVar("caption", "YOU WIN")
		levelText.setVar("position", (self.screenWidth/2-50, self.screenHeight/2-100, 0))
		levelText.setVar("size", GLUT_BITMAP_TIMES_ROMAN_24)
		levelText.timeToLive = 3
		self.gfxServer.lateObjects.append(levelText)
		
		menuManager = self.getFirstObjectOfName("menuManager")
		menuManager.menuText.setVar("render", True)
		menuManager.setVar("menuState", "show")
	elif cmd == "gameOver":
	    self.invaderManager.setVar("maxInvaders", 1)
	    self.invaderManager.setVar("numInvaders", 2)
	    levelText = Text(self)
	    levelText.setVar("caption", "YOU LOSE\nGAME OVER")
	    levelText.setVar("position", (self.screenWidth/2-50, self.screenHeight/2-100, 0))
	    levelText.setVar("size", GLUT_BITMAP_TIMES_ROMAN_24)
	    levelText.timeToLive = 5
	    self.gfxServer.lateObjects.append(levelText)
		
	    for child in self.invaderManager.children.itervalues():
		child.delete()
	
	    menuManager = self.getFirstObjectOfName("menuManager")
	    menuManager.menuText.setVar("render", True)
	    menuManager.setVar("menuState", "show")
