from object import Object
from text import Text
from OpenGL.GLUT import *
from keys import keys

class MenuManager(Object):
    def __init__(self, parent, type = None, name = None):
	Object.__init__(self, parent, type, name)
	
	self.defaultVar("menuState", "hide")
	
    def init(self):
	inputServer = self.getFirstObjectOfName("inputServer")
	inputServer.addSubscriber(self)
	
	self.gfxServer = self.getFirstObjectOfName("gfxServer")
	self.screenWidth = self.gfxServer.getVar("screenWidth")
	self.screenHeight = self.gfxServer.getVar("screenHeight")
	
	self.topBar = Text(self)
	self.topBar.setVar("size", GLUT_BITMAP_HELVETICA_18)
	self.topBar.setVar("caption", "Press Escape for Menu")
	self.topBar.setVar("position", (5, 5, 0))
	self.gfxServer.lateObjects.append(self.topBar)
	
	self.menuText = Text(self)
	self.menuText.setVar("caption", "MAIN MENU\n\na) Restart Game\nb) Quit Game")
	self.menuText.setVar("size", GLUT_BITMAP_HELVETICA_18)
	self.menuText.setVar("position", (self.screenWidth/2-50, self.screenHeight/2+150, 0))
	self.gfxServer.lateObjects.append(self.menuText);
	self.menuText.setVar("render", False)

    def receiveMessage(self, cmd, msg = None):
	if (cmd == "keyDown"):
	    if msg == keys['escape']:
		if self.getVar("menuState") == "show":
		    self.menuText.setVar("render", False)
		    self.setVar("menuState", "hide")
		elif self.getVar("menuState") == "hide":
		    self.menuText.setVar("render", True)
		    self.setVar("menuState", "show")
	    elif msg == keys['a']:
		if self.getVar("menuState") == "show":
		    levelManager = self.getFirstObjectOfName("levelManager")
		    levelManager.setVar("gameLevel", 1)
		    
		    background = self.getFirstObjectOfName("background")
		    background.gfx.setVar("texture", "level1bg.png")
		    
		    levelText = Text(self)
		    levelText.setVar("caption", "LEVEL 1")
		    levelText.setVar("position", (self.screenWidth/2-50, self.screenHeight/2-100, 0))
		    levelText.setVar("size", GLUT_BITMAP_TIMES_ROMAN_24)
		    levelText.timeToLive = 3
		    self.gfxServer.lateObjects.append(levelText)
		    
		    invaderManager = self.getFirstObjectOfName("invaderManager")
		    invaderManager.setVar("numInvaders", 0)
		    invaderManager.setVar("numCurrentInvaders", 0)
		    invaderManager.setVar("maxInvaders", 20)
		    invaderManager.setVar("maxCurrentInvaders", 3)
		    for child in invaderManager.children.itervalues():
			child.delete()
		    
		    planet = self.getFirstObjectOfName("planet")
		    print planet.getVar("numCities")
		    planet.setVar("numCities", 10)
		    print planet.getVar("numCities")
		    
		    defender = self.getFirstObjectOfName("defender")
		    defender.setVar("ammo", 0)
		    defender.setVar("maxAmmo", 50)
		    defender.setVar("ammoRate", 5)
		    
		    self.menuText.setVar("render", False)
		    self.setVar("menuState", "hide")
	    elif msg == keys['b']:
		if self.getVar("menuState") == "show":
		    self.getRoot().setVar("terminate", True)