from sceneNode import SceneNode
from circle import Circle
from rectangle import Rectangle
from text import Text
from OpenGL.GLUT import *
import math

class Planet(SceneNode):
    def __init__(self, parent, type = None, name = None):
        SceneNode.__init__(self,  parent, type, name)
	
	self.defaultVar("hitRadius", 25)
	self.defaultVar("numCities", 10)
	self.defaultVar("maxCities", 10)
	
	r = self.getVar("hitRadius")
	self.setVar("scale", (r*2,r*2,r*2))
	self.setVar("color", (0,0,1))
	
	self.gfx = Rectangle(self)
	self.gfx.setVar("texture", "planet.png")
	self.gfx.setVar("numSections", 30)
	
    def init(self):
	self.invaderManager = self.getFirstObjectOfName("invaderManager")
	
	self.gfxServer = self.getFirstObjectOfName("gfxServer")
	self.screenWidth = self.gfxServer.getVar("screenWidth")
	self.screenHeight = self.gfxServer.getVar("screenHeight")
	
	self.setVar("position", (self.screenWidth/2, self.screenHeight/2, 0))
	
	self.cityText = Text(self)
	caption = "Planet Health (Cities):   %i/%i" % (self.getVar("numCities"), self.getVar("maxCities"))
	self.cityText.setVar("caption", caption)
	self.cityText.setVar("position", (self.screenWidth-250, self.screenHeight-25, 0))
	self.cityText.setVar("size", GLUT_BITMAP_HELVETICA_18)
	self.gfxServer.lateObjects.append(self.cityText)
	
    def update(self, timeTotal, timeDiff):
	#print self.getVar("numCities")
	for invader in self.invaderManager.children.itervalues():
	    if invader.initialized and not invader.destroyed and not invader.getVar("dead"):
		x1,y1,z1 = self.getVar("position")
	        x2,y2,z2 = invader.getVar("position")
	        r1 = self.getVar("hitRadius")
	        r2 = invader.getVar("hitRadius")
	        dist = math.sqrt( (x2-x1)**2 + (y2-y1)**2 + (z2-z1)**2 )
	        if dist < r1 + r2:
		    numInvaders = self.invaderManager.getVar("numCurrentInvaders")
		    self.invaderManager.setVar("numCurrentInvaders", numInvaders - 1)
		    invader.setVar("dead", True)
		    invader.delete()
		    self.setVar("numCities", self.getVar("numCities") -1)
		    if self.getVar("numCities") == 0:
			self.publish("gameOver", "")
	caption = "Planet Health (Cities):   %i/%i" % (self.getVar("numCities"), self.getVar("maxCities"))
	self.cityText.setVar("caption", caption)